#include "TextCollectionBuilder.h"
#include "FMIndexBuilder.h"
#include "SWCSABuilder.h"
#include "RLCSABuilder.h"

namespace SXSI
{
TextCollectionBuilder* TextCollectionBuilder::create(unsigned samplerate, 
                                     index_type_t type,
                                     ulong estimatedInputLength)
{
    switch (type)
    {
    case index_type_default:
        return new FMIndexBuilder(samplerate, estimatedInputLength);
        break;
    case index_type_swcsa:
        return new SWCSABuilder(samplerate);
        break;
    case index_type_rlcsa:
        return new RLCSABuilder(samplerate, estimatedInputLength);
        break;
    }
    std::cerr << "TextCollectionBuilder::create(): unknown type given: expecting enum value, type = " << type << std::endl;
    std::exit(2);
}

} // Namespace SXSI
