#include "stdio.h"
#include "string.h"
#include "lztrie.h"

int main()
{
    byte *text = (byte*)"ababacaaaaaaaaaaaaaaaaaaaffffffffffffffdddddddddssssssssssfffffffffffzzzbbbbbbbbbbbbbbbbbbbbbbbbbabababaccacacababababababababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaacccdsfffffffffffffffffffffffaslkfjasldjfasjdgajsdfljasdkfljalsdjkfskjflakjdfklajdkfjlasldjfagoiubvoixcupvozucvpouizxcpovui,qwner.,qwenrqbwe,rbqwmerbmwerbm";
    ulong n = strlen((char *)text);
    ulong i;
    byte *newt = 0;
    ulong l = 0;

    lztrie lz = buildLZTrie(text, 0, n);
        
    printf("extracting:\n");
    extract(lz, 0, n, &newt, &l);
    for (i = 0; i < n; ++i)
        if (newt[i]  != text[i]) {
            printf("texts differ at %lu\n", i);
            exit(0);
        }

    free(newt);

    FILE *fp = fopen("output.lz", "wb");
    saveLZTrie(lz, fp);
    fclose(fp);
    destroyLZTrie(lz);

    fp = fopen("output.lz", "rb");
    lz = loadLZTrie(fp);
    fclose(fp);

    printf("extracting:\n");
    extract(lz, 0, n, &newt, &l);
    for (i = 0; i < n; ++i)
        if (newt[i]  != text[i]) {
            printf("texts differ at %lu\n", i);
            exit(0);
        }

    free(newt);

    destroyLZTrie(lz);
    return 0;
}
