#ifndef BP_DARRAY_H_
#define BP_DARRAY_H_

#ifdef __cplusplus
extern "C" {
#endif
#include "bp-utils.h"

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;

#define OPT_NO_RANK (1<<30)


typedef dword pb;


typedef struct {
  int n,m;
  int size;
  pb *buf;
  dword *lp;
  dword *sl;
  word *ss;
  dword *p;

  dword *rl;
  word *rm;
  byte *rs;

  int idx_size;
} darray;


darray * bp_darray_construct(int n, pb *buf,int opt);
void bp_darray_free(darray *da);

int bp_darray_select(darray *da, int i,int f);

static inline int bp_darray_rank(darray *da, int i)
{
  int r,j,i_rr, i_rrr;
  int offset;
  pb *p;
  byte *buff;
  i_rr = i >> logRR;
  i_rrr = i >> logRRR;
  r = da->rl[i>>logR] + da->rm[i_rr];

  j = (i_rrr) & (RR/RRR-1);
  offset = i_rr << (logRR-logRRR);
  buff = &(da->rs[offset-1]);
  while (j > 0) {
    r += buff[j];
    j--;
  }

  p = da->buf + ((i_rrr)<<(logRRR-logD));
  j = i & (RRR-1);
  while (j >= D) {
    r += popcount(*p++);
    j -= D;
  }
  r += popcount(*p >> (D-1-j));

  return r;
}

darray * bp_darray_pat_construct(int n, pb *buf, int k, pb pat, int opt);
int bp_darray_pat_select(darray *da, int i, pb (*getpat)(pb *));
int bp_darray_pat_rank(darray *da, int i, pb (*getpat)(pb *));

int bp_darray_select_bsearch(darray *da, int i, pb (*getpat)(pb *));



#ifdef __cplusplus
}
#endif


#endif
