
#ifndef _STATIC_BITSEQUENCE_SDARRAY_H
#define _STATIC_BITSEQUENCE_SDARRAY_H

#include <basics.h>
#include <static_bitsequence.h>
#include <sdarray.h>

class static_bitsequence_sdarray: public static_bitsequence {
	protected:
		selects3 sd;
		static_bitsequence_sdarray();

public:
		static_bitsequence_sdarray(uint * buff, uint len);
		static_bitsequence_sdarray(uint * buff, uint len, uint);
		~static_bitsequence_sdarray();

		virtual uint select1(uint i);
		virtual uint rank1(uint i);
		virtual uint select_next1(uint i);
		inline uint select(uint i) {
			 if(i>ones || i==0) return -1;
			 if(ones)
				 return selects3_select(&this->sd,i);
			 else
				 return (uint)-1;
		 }

		 inline uint rank(uint i)  {
			 if(i>=len) return -1;
			 if(ones)
				 return selects3_rank(&this->sd, i);
			 else
				 return 0;
		 }

		 inline uint select_next(uint i)  {
			 return selects3_selectnext(&this->sd,i);
		 }

		uint size();
		int save(FILE * fp);
		static static_bitsequence_sdarray * load(FILE * fp);

};

#endif

