type t =
    { id : int;
      states : StateSet.t;
      init : StateSet.t;
      last : State.t;

    (* Transitions of the Alternating automaton *)
      trans : (State.t, (TagSet.t * Transition.t) list) Hashtbl.t;
      marking_states : StateSet.t;
      topdown_marking_states : StateSet.t;
      bottom_states : StateSet.t;
      true_states : StateSet.t   }

val print : Format.formatter -> t -> unit

type jump_kind =
    NIL
  | NODE
  | STAR
  | JUMP_ONE of Ptset.Int.t
  | JUMP_MANY of Ptset.Int.t
  | CAPTURE_MANY of Ptset.Int.t

val print_kind : Format.formatter -> jump_kind -> unit

val top_down_approx : t -> StateSet.t -> Tree.t -> jump_kind

val init : unit -> unit
val get_trans : ?attributes:TagSet.t -> t -> StateSet.t -> Tag.t -> Translist.t * StateSet.t * StateSet.t
