#ifndef COMMON_STUB_HPP_
#define COMMON_STUB_HPP_

extern "C" {
#define CAML_NAME_SPACE

#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>
#include <caml/callback.h>
#include <caml/fail.h>
#include <caml/custom.h>
#include <caml/bigarray.h>
}
#include <typeinfo>

#define NoAlloc


void register_custom_(char* name,
		      size_t size,
		      void (*finalize)(value v));

value alloc_custom_(char* name);

template <class X> X& Obj_val(value v)
{
  return * (X*) Data_custom_val(v);
}

template <class X> void sxsi_finalize_obj(X) {
}

template <class X> void sxsi_finalize_obj(X* x){
  delete x;
}

template <class X> void sxsi_finalize_custom(value v)
{
  sxsi_finalize_obj(Obj_val<X>(v));
}

template <class X> value
sxsi_alloc_custom(void (*finalize)(value) = sxsi_finalize_custom<X>)
{
  char * name = const_cast<char*>(typeid(X).name());

  value v = alloc_custom_(name);
  if (v == Val_unit) {
    register_custom_(name, sizeof(X), finalize);
    v = alloc_custom_(name);
  };
  return v;
}

void sxsi_raise_msg(const char * msg);

extern "C" value sxsi_cpp_init(value unit);



#endif
