module type S = sig
  type result_set
  val top_down_run : Ata.t -> Tree.t -> Tree.node -> result_set
  val bottom_up_run : Ata.t -> Tree.t -> Tree.text_query * string -> result_set
  val grammar_run : Ata.t -> Grammar2.t -> unit -> result_set
  val naive_top_down_run : Ata.t -> Tree.t -> Tree.node -> result_set
  val twopass_top_down_run : Ata.t -> Tree.t -> Tree.node -> result_set
end

module Make (U : ResJIT.S) : S with type result_set = U.NS.t
