open Format

include Ptset.Make (
  struct type t = int
	 type data = t
	 external hash : t -> int = "%identity"
	 external uid : t -> Uid.t = "%identity"
	 external equal : t -> t -> bool = "%eq"
	 external make : t -> int = "%identity"
	 external node : t -> int = "%identity"
	 external stats : unit -> unit = "%identity"
         external init : unit -> unit = "%identity"
  end
)

let print ppf s =
  let first = ref true in
    pp_print_string ppf "{";
    iter
      (fun i ->
	 if !first
	 then let () = State.print ppf i in first := false
	 else fprintf ppf " %a" State.print i)
      s;
    pp_print_string ppf "}"
