type node = State.t * TagSet.t * bool * Formula.t
type data = node
type t
val make : data -> t
val node : t -> data
val hash : t -> int
val uid : t -> Uid.t
val equal : t -> t -> bool
val stats : unit -> unit
val compare : t -> t -> int
val init : unit -> unit

module Infix : sig
  val ( ?< ) : State.t -> State.t
  val ( >< ) : State.t -> TagSet.t * bool -> State.t * (TagSet.t * bool * bool)
  val ( ><@ ) : State.t -> TagSet.t * bool -> State.t * (TagSet.t * bool * bool)
  val ( >=> ) : State.t * (TagSet.t * bool * bool) -> Formula.t -> (State.t * TagSet.t * t)
end

val print : Format.formatter -> t -> unit
val format_list : t list -> string list
