#!/bin/bash

source utils.sh

function do_sxsi() {
    query="$1"
    count="$4"
    doc=`basename "$2" .xml`.srx
    repeat="$3"
    TIME_MAT=""
    TIME_COUNT=""
    TIME_PRINT=""
    NUM_RESULTS=""
    output=`./main.native -r "$3" -c -b "$doc" "$query" 2>&1`
    echo "$query" >> sxsi_debug.log
    echo "$output" >> sxsi_debug.log
    NUM_RESULT=`echo "$output" | grep "Number of results" | grep -o '[0-9]*'`
    time=`echo "$output" | grep "Execution time" | cut -f 2 -d',' | cut -f1 -d ':' | grep -o '[0-9.]*'`
    TIME_COUNT=`echo "$time" | tail -n +2 | average`
    if [ -z "$count" ]
    then
	output=`./main.native -b -r "$3" "$doc" "$query" /dev/null 2>&1`
	mtime=`echo "$output" | grep "Execution time" | cut -f 2 -d',' | cut -f1 -d ':'| grep -o '[0-9.]*'`
	ptime=`echo "$output" | grep 'Serialization time' | cut -f 3 -d ' ' | grep -o '[0-9.]*'`
	TIME_MAT=`echo "$mtime" | tail -n +2 | average`
	TIME_PRINT="$ptime"
    else
	TIME_MAT="999999"
	TIME_PRINT="0"
    fi

    echo "$TIME_COUNT"
    echo "$TIME_MAT"
    echo "$TIME_PRINT"
    echo $NUM_RESULT
}

do_sxsi "$@"
